;;; $DOOMDIR/config.el -*- lexical-binding: t; -*-

;; Place your private configuration here! Remember, you do not need to run 'doom
;; sync' after modifying this file!


;; Some functionality uses this to identify you, e.g. GPG configuration, email
;; clients, file templates and snippets.
(setq user-full-name "Levi Olson"
      user-mail-address "olson.levi@gmail.com")

;; Doom exposes five (optional) variables for controlling fonts in Doom. Here
;; are the three important ones:
;;
;; + `doom-font'
;; + `doom-variable-pitch-font'
;; + `doom-big-font' -- used for `doom-big-font-mode'; use this for
;;   presentations or streaming.
;;
;; They all accept either a font-spec, font string ("Input Mono-12"), or xlfd
;; font string. You generally only need these two:
;; (setq doom-font (font-spec :family "monospace" :size 12 :weight 'semi-light)
;;       doom-variable-pitch-font (font-spec :family "sans" :size 13))

;; There are two ways to load a theme. Both assume the theme is installed and
;; available. You can either set `doom-theme' or manually load a theme with the
;; `load-theme' function. This is the default:
(setq doom-theme 'doom-one)

;; If you use `org' and don't want your org files in the default location below,
;; change `org-directory'. It must be set before org loads!
(setq org-directory "/mnt/c/Users/Levi/Nextcloud/Org/")

;; This determines the style of line numbers in effect. If set to `nil', line
;; numbers are disabled. For relative line numbers, set this to `relative'.
(setq display-line-numbers-type t)

(cond ((member "PragmataPro Liga" (font-family-list))
       (set-face-attribute 'default nil :font "PragmataPro Liga-15")))

(if (eq system-type 'gnu/linux)
    (progn
      (add-to-list 'default-frame-alist '(top . 400))
      (add-to-list 'default-frame-alist '(left . 750))
      (add-to-list 'default-frame-alist '(height . 60))
      (add-to-list 'default-frame-alist '(width . 235))
      ))

;; Here are some additional functions/macros that could help you configure Doom:
;;
;; - `load!' for loading external *.el files relative to this one
;; - `use-package!' for configuring packages
;; - `after!' for running code after a package has loaded
;; - `add-load-path!' for adding directories to the `load-path', relative to
;;   this file. Emacs searches the `load-path' when you load packages with
;;   `require' or `use-package'.
;; - `map!' for binding new keys
;;
;; To get information about any of these functions/macros, move the cursor over
;; the highlighted symbol at press 'K' (non-evil users must press 'C-c c k').
;; This will open documentation for it, including demos of how they are used.
;;
;; You can also try 'gd' (or 'C-c c d') to jump to their definition and see how
;; they are implemented.

(if (file-exists-p "~/.doom.d/functions.el")
    (progn
      (load-file "~/.doom.d/functions.el")
      (require 'functions))
  (message "\"~/.doom.d/functions.el\" does not exist" ))

(map! :map global-map
      "M-t"     'treemacs-select-window
      "M-q"     'leo/kill-this-buffer-unless-scratch

      "C-<tab>" 'leo/tidy
      "C-;"     'leo/comment-or-uncomment-region-or-line
      "C-c C-e" 'leo/edit-config
      "C-c d"   'leo/duplicate-thing
      "M-n"     'leo/jump-to-next-symbol
      "M-p"     'leo/jump-to-prev-symbol
      "M-u"     'upcase-dwim
      "M-c"     'capitalize-dwim
      "M-l"     'downcase-dwim

      "C-c b"   'ivy-switch-buffer
      "C-s"     'swiper

      "C-}"     'mc/mark-next-like-this
      "C-)"     'mc/unmark-next-like-this
      "C-{"     'mc/mark-previous-like-this
      "C-("     'mc/unmark-previous-like-this
      "C-@"     'er/expand-region
      "C-#"     'er/contract-region
      )
